/*
 * This file was generated by the CommonAPI Generators.
 * Used org.genivi.commonapi.someip 3.2.0.v202012010944.
 * Used org.franca.core 0.13.1.201807231814.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
 * If a copy of the MPL was not distributed with this file, You can obtain one at
 * http://mozilla.org/MPL/2.0/.
 */
#ifndef V1_COMMONAPI_TELUX_CV2X_CV2X_RADIO_MANAGER_SOMEIP_STUB_ADAPTER_HPP_
#define V1_COMMONAPI_TELUX_CV2X_CV2X_RADIO_MANAGER_SOMEIP_STUB_ADAPTER_HPP_

#include <v1/commonapi/telux/cv2x/Cv2xRadioManagerStub.hpp>
#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesSomeIPStubAdapter.hpp>
#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesSomeIPDeployment.hpp>
#include <v1/commonapi/telux/common/CommonDefinesSomeIPDeployment.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/SomeIP/AddressTranslator.hpp>
#include <CommonAPI/SomeIP/StubAdapterHelper.hpp>
#include <CommonAPI/SomeIP/StubAdapter.hpp>
#include <CommonAPI/SomeIP/Factory.hpp>
#include <CommonAPI/SomeIP/Types.hpp>
#include <CommonAPI/SomeIP/Constants.hpp>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace cv2x {

template <typename _Stub = ::v1::commonapi::telux::cv2x::Cv2xRadioManagerStub, typename... _Stubs>
class Cv2xRadioManagerSomeIPStubAdapterInternal
    : public virtual Cv2xRadioManagerStubAdapter,
      public ::v1::commonapi::telux::cv2x::Cv2xRadioTypesSomeIPStubAdapterInternal<_Stub, _Stubs...>
{
public:
    typedef CommonAPI::SomeIP::StubAdapterHelper< _Stub, _Stubs...> Cv2xRadioManagerSomeIPStubAdapterHelper;

    ~Cv2xRadioManagerSomeIPStubAdapterInternal() {
        deactivateManagedInstances();
        Cv2xRadioManagerSomeIPStubAdapterHelper::deinit();
    }

    void fireCurrentCv2xStatusEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus &_status);

    void deactivateManagedInstances() {}
    
    virtual void init(std::shared_ptr<CommonAPI::SomeIP::StubAdapter> instance) {
        return Cv2xRadioManagerSomeIPStubAdapterHelper::init(instance);
    }

    virtual void deinit() {
        return Cv2xRadioManagerSomeIPStubAdapterHelper::deinit();
    }

    virtual bool onInterfaceMessage(const CommonAPI::SomeIP::Message &_message) {
        return Cv2xRadioManagerSomeIPStubAdapterHelper::onInterfaceMessage(_message);
    }
    
    CommonAPI::SomeIP::GetAttributeStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioManagerStub,
        CommonAPI::Version
    > getCv2xRadioManagerInterfaceVersionStubDispatcher;

    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioManagerStub,
        std::tuple< >,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines::ErrorCode, ::v1::commonapi::telux::common::CommonDefines::ServiceStatus>,
        std::tuple< >,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t, ::v1::commonapi::telux::common::CommonDefines_::ServiceStatusDeployment_t>
    > getServiceStatusStubDispatcher;
    
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioManagerStub,
        std::tuple< >,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines::ErrorCode, ::v1::commonapi::telux::common::CommonDefines::Status>,
        std::tuple< >,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t, ::v1::commonapi::telux::common::CommonDefines_::StatusDeployment_t>
    > startCv2xStubDispatcher;
    
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioManagerStub,
        std::tuple< >,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines::ErrorCode, ::v1::commonapi::telux::common::CommonDefines::Status>,
        std::tuple< >,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t, ::v1::commonapi::telux::common::CommonDefines_::StatusDeployment_t>
    > stopCv2xStubDispatcher;
    
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioManagerStub,
        std::tuple< >,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines::ErrorCode, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus>,
        std::tuple< >,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xStatusDeployment_t>
    > requestCv2xStatusStubDispatcher;
    
    CommonAPI::SomeIP::MethodWithReplyStubDispatcher<
        ::v1::commonapi::telux::cv2x::Cv2xRadioManagerStub,
        std::tuple< >,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines::ErrorCode, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatusEx>,
        std::tuple< >,
        std::tuple< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xStatusExDeployment_t>
    > requestCv2xStatusExStubDispatcher;
    
    Cv2xRadioManagerSomeIPStubAdapterInternal(
        const CommonAPI::SomeIP::Address &_address,
        const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection,
        const std::shared_ptr<CommonAPI::StubBase> &_stub):
        CommonAPI::SomeIP::StubAdapter(_address, _connection),
                ::v1::commonapi::telux::cv2x::Cv2xRadioTypesSomeIPStubAdapterInternal<_Stub, _Stubs...>(_address, _connection, _stub),
        getCv2xRadioManagerInterfaceVersionStubDispatcher(&Cv2xRadioManagerStub::lockInterfaceVersionAttribute, &Cv2xRadioManagerStub::getInterfaceVersion, false, true),
        getServiceStatusStubDispatcher(
            &Cv2xRadioManagerStub::GetServiceStatus,
            false,
            _stub->hasElement(0),
            std::make_tuple(),
            std::make_tuple(static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t * >(nullptr), static_cast< ::v1::commonapi::telux::common::CommonDefines_::ServiceStatusDeployment_t* >(nullptr)))
        
        ,
        startCv2xStubDispatcher(
            &Cv2xRadioManagerStub::startCv2x,
            false,
            _stub->hasElement(2),
            std::make_tuple(),
            std::make_tuple(static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t * >(nullptr), static_cast< ::v1::commonapi::telux::common::CommonDefines_::StatusDeployment_t* >(nullptr)))
        
        ,
        stopCv2xStubDispatcher(
            &Cv2xRadioManagerStub::stopCv2x,
            false,
            _stub->hasElement(3),
            std::make_tuple(),
            std::make_tuple(static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t * >(nullptr), static_cast< ::v1::commonapi::telux::common::CommonDefines_::StatusDeployment_t* >(nullptr)))
        
        ,
        requestCv2xStatusStubDispatcher(
            &Cv2xRadioManagerStub::requestCv2xStatus,
            false,
            _stub->hasElement(4),
            std::make_tuple(),
            std::make_tuple(static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t * >(nullptr), static_cast< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xStatusDeployment_t* >(nullptr)))
        
        ,
        requestCv2xStatusExStubDispatcher(
            &Cv2xRadioManagerStub::requestCv2xStatusEx,
            false,
            _stub->hasElement(5),
            std::make_tuple(),
            std::make_tuple(static_cast< ::v1::commonapi::telux::common::CommonDefines_::ErrorCodeDeployment_t * >(nullptr), static_cast< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xStatusExDeployment_t* >(nullptr)))
        
    {
        Cv2xRadioManagerSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x7530) }, &getServiceStatusStubDispatcher );
        Cv2xRadioManagerSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x7531) }, &startCv2xStubDispatcher );
        Cv2xRadioManagerSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x7532) }, &stopCv2xStubDispatcher );
        Cv2xRadioManagerSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x7533) }, &requestCv2xStatusStubDispatcher );
        Cv2xRadioManagerSomeIPStubAdapterHelper::addStubDispatcher( { CommonAPI::SomeIP::method_id_t(0x7534) }, &requestCv2xStatusExStubDispatcher );
        // Provided events/fields
        {
            std::set<CommonAPI::SomeIP::eventgroup_id_t> itsEventGroups;
            itsEventGroups.insert(CommonAPI::SomeIP::eventgroup_id_t(0x80f2));
            CommonAPI::SomeIP::StubAdapter::registerEvent(CommonAPI::SomeIP::event_id_t(0x80f2), itsEventGroups, CommonAPI::SomeIP::event_type_e::ET_EVENT, CommonAPI::SomeIP::reliability_type_e::RT_UNRELIABLE);
        }
    }

    // Register/Unregister event handlers for selective broadcasts
    void registerSelectiveEventHandlers();
    void unregisterSelectiveEventHandlers();

};

template <typename _Stub, typename... _Stubs>
void Cv2xRadioManagerSomeIPStubAdapterInternal<_Stub, _Stubs...>::fireCurrentCv2xStatusEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus &_status) {
    CommonAPI::Deployable< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xStatusDeployment_t> deployed_status(_status, static_cast< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xStatusDeployment_t* >(nullptr));
    CommonAPI::SomeIP::StubEventHelper<CommonAPI::SomeIP::SerializableArguments<  CommonAPI::Deployable< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xStatusDeployment_t > 
    >>
        ::sendEvent(
            *this,
            CommonAPI::SomeIP::event_id_t(0x80f2),
            false,
             deployed_status 
    );
}


template <typename _Stub, typename... _Stubs>
void Cv2xRadioManagerSomeIPStubAdapterInternal<_Stub, _Stubs...>::registerSelectiveEventHandlers() {
}

template <typename _Stub, typename... _Stubs>
void Cv2xRadioManagerSomeIPStubAdapterInternal<_Stub, _Stubs...>::unregisterSelectiveEventHandlers() {
}

template <typename _Stub = ::v1::commonapi::telux::cv2x::Cv2xRadioManagerStub, typename... _Stubs>
class Cv2xRadioManagerSomeIPStubAdapter
    : public Cv2xRadioManagerSomeIPStubAdapterInternal<_Stub, _Stubs...> {
public:
    Cv2xRadioManagerSomeIPStubAdapter(const CommonAPI::SomeIP::Address &_address,
                                            const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection,
                                            const std::shared_ptr<CommonAPI::StubBase> &_stub)
        : CommonAPI::SomeIP::StubAdapter(_address, _connection),
          Cv2xRadioManagerSomeIPStubAdapterInternal<_Stub, _Stubs...>(_address, _connection, _stub) {
    }
};

} // namespace cv2x
} // namespace telux
} // namespace commonapi
} // namespace v1

#endif // V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Manager_SOMEIP_STUB_ADAPTER_HPP_
